#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <bitset>

int main(void)
{

	// Bit <-> Dec conversion:
	// http://www.mathsisfun.com/binary-decimal-hexadecimal-converter.html
	unsigned int ByteIncr = 0, int_array [9] = {1, 1, 1, 1, 1, 1, 1, 1, 1};
	unsigned char BitIncr = 0, BitsToRead = 5, char_array [27] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	
	unsigned int temp = 0;
	unsigned char BitsToWrite = BitsToRead;
	for(unsigned int i = 0; i < 8; ++i)
	{
		// 11111222 22333334 44445555 56666677 77788888 repeat 
		// First read:  +0, << 0
		// Second read: +3, << 7
		// Third read:  +6, << 6
		/*
		std::cout << "  BitIncr: " << (unsigned int)BitIncr <<"; ByteIncr: " << ByteIncr
				  << "; " << std::endl;
		std::cout << "  Characters: " << *(unsigned int *)&int_array[ByteIncr] << ";" << std::endl;
		std::cout << "  " <<  << ";" << std::endl;
*/
/*		temp = *(unsigned int *)((char *)&int_array+ByteIncr);
		std::cout << temp << " = " << std::bitset<sizeof(int)*8> (temp) << " << " << (unsigned int)BitIncr << ":" << std::endl;
		temp <<= BitIncr;
		std::cout << temp << " = " << std::bitset<sizeof(int)*8> (temp) << "; >> " << (unsigned int)(32-BitsToRead) << std::endl;
		temp >>= (32-BitsToRead);
		std::cout << temp << " = " << std::bitset<sizeof(int)*8> (temp) << "." << std::endl;
		char_array[i] |= temp;*/

		//
		// ATM: 4 zeros and 5 zeros. 2 extra pad bytes at start, several at end.
		//


		temp = (int_array[i] << (32-BitsToWrite));
		std::cout << temp << "\t = " << std::bitset<sizeof(int)*8> (temp) << " << " << (unsigned int)(32-BitsToWrite) << ", >> " << (unsigned int)(8-BitIncr) << ":" << std::endl;
		temp >>= (8-BitIncr);
		std::cout << temp << "\t = " << std::bitset<sizeof(int)*8> (temp) << "." << std::endl;

		std::cout << "Combo of:" << std::endl
				  << std::bitset<sizeof(int)*8> (*(unsigned int *)(&char_array[ByteIncr])) << std::endl
				  << std::bitset<sizeof(int)*8> (temp) << std::endl << std::endl;
		
		*(unsigned int *)(&char_array[ByteIncr]) |= temp;
		
		// OUTPUT: ORIGINAL INT
		/*std::cout << (unsigned int)char_array[i] << "\t"
				  << std::bitset<sizeof(char)*8> ((unsigned int)char_array[i]) << std::endl;
		*/
		// Increase reading address
		BitIncr += BitsToRead;
		
		// Crop reading position to bits & bytes
		while(BitIncr >= 8) 
		{
			BitIncr -= 8;
			++ByteIncr;
		}

		/* TRY:
		
		(*(unsigned int *)(BitStack[ByteIncr]) >> BitIncr) |= (ArrayOfUInts[i] << (32-BitsToWrite));
		
		*/
	}
	// Output all variables
	for(unsigned char a = 0; a < 26; ++a)
	{
		//std::cout << "#" << (unsigned int) a << ": " << (unsigned int)char_array[a] << std::endl;
		std::cout << std::bitset<8> (char_array[a]) << " ";
	}
	// Cleanup
	std::cout << "Converting back: Cleaning variables." << std::endl;
	ByteIncr = 0;
	BitIncr = 0;
	BitsToRead = 5;
	memset(&int_array, 0, sizeof(int)*8);





	//{1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27}

	// 00000001 00000001 00000001 00000001 00000001 00000001
	// 00000 00100 00000 10000 00010 00000 01000 00001 00000 001
	// 0, 4, 0, 16, 2, 0, 8, 1, 0,                           ^^^ PAD
	// 00000001 00000001 00000001 00000001 00000001 00000001
	// 000000 010000 000100 000001 000000 010000 000100 000001
	// 0, 16, 4, 1, 0, 16, 4, 1, 0
	// 0000000100000001000000010000000 1000000010000000100000001000000 10000001000000100000010000001000000
	
	// Loop through bitstack
	// (NB: 8 here is the number of BitsToRead in the char array - the number of variables in the bitstack)
	// This is not needed in our application, therefore it is not calculated here.
	for(unsigned int a = 0; a < 8; ++a)
	{
		// This works fine for 1-bit to 23-bit, since 23 bits, bitshifted, cannot be spread over more
		// than 4 bytes, which means an int * can pick all the bits up

		// This also works fine for 32-bit & 24-bit, because they are both multiples of 8, so BitIncr is always 0,
		// so the bits are never spread across multiple bytes, so they can be read plainly without any bit-shifting
		if(BitsToRead == 32 || BitsToRead < 25)
			int_array[a] = *(unsigned int *)&char_array[ByteIncr] >> (32-BitsToRead-BitIncr);
		else // BitsToRead != 32 && BitsToRead >= 25
		{
			unsigned int b = 0, c = 0, d = 0;
			// NB: Using 32-BitsToRead-BitIncr is incorrect for some reason: the 2+nd times, the first bit set to 1 vanishes
			// However this may be due to an incorrect bitshift?
			// Expected:
			// 0: << 0, >> 1
			// 1: << 7, char >> 7
			// 2: >>
			
			// OUTPUT: ORIGINAL INT
			std::cout << *(unsigned int *)(&char_array[ByteIncr]) << "\t\t"
					  << std::bitset<sizeof(int)*8> (*(unsigned int *)(&char_array[ByteIncr])) << " " 
					  << std::bitset<sizeof(char)*8> (*(unsigned char *)(&char_array[ByteIncr+4])) << std::endl;
			
			// Does bitshift exclude valuable bits in the 5th byte?
			if(BitIncr % 8 == 0)
			{
				// OUTPUT: INT BITSHIFT
				std::cout << "Shifted >> " << (32-BitsToRead-BitIncr) << " makes:" << std::endl;
				b = *(unsigned int *)(&char_array[ByteIncr]) >> (32-BitsToRead-BitIncr);
				
				// OUTPUT: SHIFTED INT
				std::cout << b << "\t\t" << std::bitset<sizeof(int)*8> (b) << std::endl;
			}
			else // (BitIncr % 8 != 0)
			{
				// OUTPUT: INT BITSHIFT
				std::cout << "Shifted << " << (32-BitsToRead+BitIncr) << " makes:" << std::endl;
				// Move bitshift across ready for combining with 5th byte's bits
				b = *(unsigned int *)(&char_array[ByteIncr]) << (BitIncr);
				b >>= 8-BitIncr;

				// OUTPUT: SHIFTED
				std::cout << " << " << (unsigned int)(BitIncr) << std::endl;
				std::cout << b << "\t\t" << std::bitset<sizeof(int)*8> (b) << std::endl;
				
				// Get the 5th byte
				std::cout << (unsigned int)(*(unsigned char *)(&char_array[ByteIncr+4])) << std::bitset<sizeof(char)*8> (*(unsigned char *)(&char_array[ByteIncr+4])) << std::endl
						  << " >> " << (unsigned int)(BitIncr) << std::endl
						  << ((unsigned int)(*(unsigned char *)&char_array[ByteIncr+4]) >> (BitsToRead-8+BitIncr)) << std::endl;
				c = (unsigned int)(((unsigned int)(*(unsigned char *)&char_array[ByteIncr+4])) >> (unsigned int)(BitIncr));
			}
			// Combine the 5th byte (if not reading 5th byte there's no change anyway)
			d = b | c;

			int_array[a] = d;
			std::cout << "OR char = " << c << "\t\t\t" << std::bitset<sizeof(char)*8> (c) << std::endl 
					  << "Final   = " << d << "\t\t" << std::bitset<sizeof(int)*8> (d) << std::endl << std::endl;
		}
		
		// Increase reading address
		BitIncr += BitsToRead;
		
		// Crop reading position to bits & bytes
		while(BitIncr >= 8) 
		{
			BitIncr -= 8;
			++ByteIncr;
		}
	}
	// 10000000 10000000 10000000 10000000 10000000 10000000
	// 10000 00010 00000 01000 00001 00000 00100 00000 10000 000
	// 16, 2, 0, 8, 1, 0, 4, 0, 16, ?
	
	/* 
		(Poss. incorrect)
		So, for 31 bits, the layout of the int, supposing 2 bits increase,
		00 0000010000000100000001000000010 0000001
		bitshift left BitIncr and | it to the bitshifted-right int
		bitshift int right 32-BitsToRead+BitIncr, back left BitIncr+(32-BitsToRead), | it to (char, bitshifted left BitIncr)
	*/

	// Output all variables
	for(unsigned char a = 0; a < 8; ++a)
	{
		std::cout << "#" << (unsigned int) a << ": " << int_array[a] << std::endl;
	}
	
	// Convert back
	std::cout << "Converting back..." << std::endl;

	// 16, 2, 0, 8, 1, 0, 4, 0, 16, ?
	system("pause");
	return 0;
}